function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/*
Copyright (c) 2018 Uber Technologies, Inc.

This source code is licensed under the MIT license found in the
LICENSE file in the root directory of this source tree.
*/
import * as React from 'react'; // Files

import { STATE_CHANGE_TYPES, KEY_STRINGS } from './constants.js';
import { scrollItemIntoView } from './utils.js'; // Types

var MenuStatefulContainer =
/*#__PURE__*/
function (_React$Component) {
  _inherits(MenuStatefulContainer, _React$Component);

  function MenuStatefulContainer() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, MenuStatefulContainer);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(MenuStatefulContainer)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "state", _objectSpread({}, _this.props.initialState));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "refList", []);

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "rootRef", React.createRef());

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onKeyDown", function (event) {
      // Up arrow
      switch (event.key) {
        case KEY_STRINGS.ArrowUp:
        case KEY_STRINGS.ArrowDown:
          _this.handleArrowKey(event.key);

          event.preventDefault();
          event.stopPropagation();
          break;

        case KEY_STRINGS.Enter:
          _this.handleEnterKey(event);

          event.preventDefault();
          break;
      }
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "getRequiredItemProps", function (item, index) {
      var highlightedIndex = _this.state.highlightedIndex;
      var _this$props = _this.props,
          onItemSelect = _this$props.onItemSelect,
          getRequiredItemProps = _this$props.getRequiredItemProps;
      var onClickHandler;

      if (onItemSelect && !item.disabled) {
        onClickHandler = function onClickHandler() {
          onItemSelect({
            item: item
          });

          _this.internalSetState(STATE_CHANGE_TYPES.click, {
            highlightedIndex: index
          });
        };
      } // Create and store ref or re-use


      var itemRef = _this.refList[index];

      if (!itemRef) {
        itemRef = React.createRef();
        _this.refList[index] = itemRef;
      }

      return _objectSpread({
        disabled: item.disabled,
        ref: itemRef,
        isHighlighted: highlightedIndex === index,
        onClick: onClickHandler,
        'aria-activedescendant': highlightedIndex === index
      }, getRequiredItemProps(item, index));
    });

    return _this;
  }

  _createClass(MenuStatefulContainer, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (typeof document !== 'undefined') {
        // TODO(#185): perhaps only bind event listener on focus
        document.addEventListener('keydown', this.onKeyDown);
        this.state.highlightedIndex > -1 && scrollItemIntoView({
          node: this.refList[this.state.highlightedIndex],
          parentNode: this.rootRef,
          isFirst: this.state.highlightedIndex === 0,
          isLast: this.state.highlightedIndex === this.props.items.length - 1
        });
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (typeof document !== 'undefined') {
        document.removeEventListener('keydown', this.onKeyDown);
      }
    } // One array to hold all of list item refs

  }, {
    key: "internalSetState",
    // Internal set state function that will also invoke stateReducer
    value: function internalSetState(changeType, changes) {
      var stateReducer = this.props.stateReducer;
      this.setState(stateReducer(changeType, changes, this.state));
    } // Regular type here because this is not done through React

  }, {
    key: "handleArrowKey",
    // Handler for arrow keys
    value: function handleArrowKey(key) {
      var items = this.props.items;
      var oldIndex = this.state.highlightedIndex;
      var highlightedIndex = oldIndex;
      var stateChangeType = null;

      if (key === KEY_STRINGS.ArrowUp) {
        highlightedIndex = Math.max(0, oldIndex - 1);
        stateChangeType = STATE_CHANGE_TYPES.moveUp;
      } else if (key === KEY_STRINGS.ArrowDown) {
        highlightedIndex = Math.min(oldIndex + 1, items.length - 1);
        stateChangeType = STATE_CHANGE_TYPES.moveDown;
      }

      scrollItemIntoView({
        node: this.refList[highlightedIndex],
        parentNode: this.rootRef,
        isFirst: highlightedIndex === 0,
        isLast: highlightedIndex === items.length - 1
      });
      this.internalSetState(stateChangeType, {
        highlightedIndex: highlightedIndex
      });
    } // Handler for enter key

  }, {
    key: "handleEnterKey",
    value: function handleEnterKey(event) {
      var _this$props2 = this.props,
          items = _this$props2.items,
          onItemSelect = _this$props2.onItemSelect;
      var highlightedIndex = this.state.highlightedIndex;

      if (items[highlightedIndex] && onItemSelect && !items[highlightedIndex].disabled) {
        onItemSelect({
          item: items[highlightedIndex],
          event: event
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var highlightedIndex = this.state.highlightedIndex;
      var _this$props3 = this.props,
          children = _this$props3.children,
          items = _this$props3.items;
      return children({
        getRequiredItemProps: this.getRequiredItemProps,
        highlightedIndex: highlightedIndex,
        items: items,
        rootRef: this.rootRef
      });
    }
  }]);

  return MenuStatefulContainer;
}(React.Component);

_defineProperty(MenuStatefulContainer, "defaultProps", {
  initialState: {
    // We start the index at -1 to indicate that no highlighting exists initially
    highlightedIndex: -1
  },
  stateReducer: function stateReducer(changeType, changes) {
    return changes;
  },
  onItemSelect: function onItemSelect() {},
  getRequiredItemProps: function getRequiredItemProps() {
    return {};
  },
  children: function children() {
    return null;
  }
});

export { MenuStatefulContainer as default };