"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _radiomark = _interopRequireDefault(require("./radiomark.js"));

var _styledComponents = require("./styled-components.js");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var StatelessRadioGroup =
/*#__PURE__*/
function (_React$Component) {
  _inherits(StatelessRadioGroup, _React$Component);

  function StatelessRadioGroup() {
    _classCallCheck(this, StatelessRadioGroup);

    return _possibleConstructorReturn(this, _getPrototypeOf(StatelessRadioGroup).apply(this, arguments));
  }

  _createClass(StatelessRadioGroup, [{
    key: "render",
    value: function render() {
      var _this = this;

      var _this$props = this.props,
          ariaLabel = _this$props.ariaLabel,
          ariaLabelledBy = _this$props.ariaLabelledBy,
          name = _this$props.name,
          children = _this$props.children,
          labelPlacement = _this$props.labelPlacement,
          isError = _this$props.isError,
          disabled = _this$props.disabled,
          align = _this$props.align,
          required = _this$props.required,
          _this$props$overrides = _this$props.overrides,
          overrides = _this$props$overrides === void 0 ? {} : _this$props$overrides;
      var sharedProps = {
        $isError: isError,
        $required: required,
        $disabled: disabled
      };
      var _overrides$Root = overrides.Root,
          Root = _overrides$Root === void 0 ? _styledComponents.Root : _overrides$Root,
          _overrides$RadioMark = overrides.RadioMark,
          RadioMark = _overrides$RadioMark === void 0 ? _radiomark.default : _overrides$RadioMark,
          _overrides$Label = overrides.Label,
          Label = _overrides$Label === void 0 ? _styledComponents.Label : _overrides$Label,
          _overrides$Input = overrides.Input,
          Input = _overrides$Input === void 0 ? _styledComponents.Input : _overrides$Input;

      var childrenProps = _objectSpread({
        name: name,
        isError: isError,
        disabled: disabled,
        required: required,
        labelPlacement: labelPlacement,
        type: 'radio',
        overrides: {
          Root: Root,
          Checkmark: RadioMark,
          Label: Label,
          Input: Input
        },
        onChange: this.props.onChange,
        onMouseEnter: this.props.onMouseEnter,
        onMouseLeave: this.props.onMouseLeave,
        onFocus: this.props.onFocus,
        onBlur: this.props.onBlur
      }, sharedProps);

      return _react.default.createElement(_styledComponents.RadioGroupRoot, _extends({
        role: "radiogroup",
        "aria-label": ariaLabel,
        "aria-labelledby": ariaLabelledBy,
        $align: align
      }, sharedProps), _react.default.Children.map(children, function (child) {
        if (!_react.default.isValidElement(child)) {
          return null;
        }

        return _react.default.cloneElement(child, _objectSpread({}, childrenProps, {
          checked: _this.props.value === child.props.value,
          disabled: _this.props.disabled || child.props.disabled
        }));
      }));
    }
  }]);

  return StatelessRadioGroup;
}(_react.default.Component);

_defineProperty(StatelessRadioGroup, "defaultProps", {
  name: '',
  value: '',
  disabled: false,
  autoFocus: false,
  labelPlacement: 'right',
  align: 'vertical',
  isError: false,
  required: false,
  onChange: function onChange() {},
  onMouseEnter: function onMouseEnter() {},
  onMouseLeave: function onMouseLeave() {},
  onFocus: function onFocus() {},
  onBlur: function onBlur() {}
});

var _default = StatelessRadioGroup;
exports.default = _default;