"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StyledCell = exports.StyledRow = exports.StyledBody = exports.StyledHeadCell = exports.StyledHead = exports.StyledTable = void 0;

var _index = require("../styles/index.js");

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var StyledTable = (0, _index.styled)('div', function (_ref) {
  var $theme = _ref.$theme;
  return _objectSpread({}, $theme.borders.border300, {
    borderRadius: $theme.borders.radius200,
    display: 'flex',
    flexDirection: 'column',
    height: '100%',
    overflowX: 'scroll'
  });
});
exports.StyledTable = StyledTable;
StyledTable.displayName = "StyledTable";
var StyledHead = (0, _index.styled)('div', function (_ref2) {
  var $theme = _ref2.$theme,
      $width = _ref2.$width;
  return {
    backgroundColor: $theme.colors.tableHeadBackgroundColor,
    boxShadow: $theme.lighting.shadow400,
    display: 'flex',
    flexGrow: 0,
    width: $width ? $width : '100%',
    zIndex: 1
  };
});
exports.StyledHead = StyledHead;
StyledHead.displayName = "StyledHead";
var StyledHeadCell = (0, _index.styled)('div', function (_ref3) {
  var $theme = _ref3.$theme;
  return _objectSpread({}, $theme.typography.font350, $theme.borders.border300, {
    borderTop: 'none',
    borderBottom: 'none',
    borderLeft: 'none',
    paddingTop: $theme.sizing.scale500,
    paddingRight: 0,
    paddingBottom: $theme.sizing.scale500,
    paddingLeft: $theme.sizing.scale600,
    width: '100%',
    ':last-of-type': {
      borderRight: 'none'
    }
  });
});
exports.StyledHeadCell = StyledHeadCell;
StyledHeadCell.displayName = "StyledHeadCell";
var StyledBody = (0, _index.styled)('div', function (_ref4) {
  var $width = _ref4.$width;
  return {
    width: $width ? $width : '100%',
    overflowY: 'scroll',
    flex: 1
  };
});
exports.StyledBody = StyledBody;
StyledBody.displayName = "StyledBody";
var StyledRow = (0, _index.styled)('div', function (_ref5) {
  var $theme = _ref5.$theme;
  return {
    display: 'flex',
    alignItems: 'center'
  };
});
exports.StyledRow = StyledRow;
StyledRow.displayName = "StyledRow";
var StyledCell = (0, _index.styled)('div', function (_ref6) {
  var $theme = _ref6.$theme;
  return _objectSpread({}, $theme.typography.font300, {
    display: 'flex',
    flex: 1,
    paddingTop: $theme.sizing.scale300,
    paddingRight: $theme.sizing.scale600,
    paddingBottom: $theme.sizing.scale300,
    paddingLeft: $theme.sizing.scale600
  });
});
exports.StyledCell = StyledCell;
StyledCell.displayName = "StyledCell";